{% load static %}
{% load i18n %}
{% get_current_language as LANGUAGE_CODE %}

<!DOCTYPE html>
<html lang="{{ LANGUAGE_CODE }}">
<head>
    <meta charset="UTF-8">
    <title>OPENCoastS Viewer</title>
    <!--<link rel="icon" href="{% static 'shared/img/favicon.ico' %}" type="image/x-icon"/>
    <link rel="shortcut icon" href="{% static 'shared/img/favicon.ico' %}" type="image/x-icon"/>-->
    <link rel="icon" type="image/png" href="{% static 'shared/img/favicon.png' %}" />

    <!-- JQuery -->
    <script src="{% static 'vendor/jquery/jquery-3.2.1.min.js' %}"></script>
    <!-- JQuery UI - IMPORTANT - custom build without tooltip widget (conflict with Bootstrap) -->
    <link rel="stylesheet" href="{% static 'vendor/jquery/jquery-ui-1.12.1.min.css' %}">
    <script src="{% static 'vendor/jquery/jquery-ui-1.12.1.min.js' %}"></script>
    <!-- Bootstrap -->
    <link rel="stylesheet" href="{% static 'vendor/bootstrap/css/bootstrap.min.css' %}">
    <link rel="stylesheet" href="{% static 'vendor/bootstrap/css/bootstrap-checkbox.css' %}">
    <script src="{% static 'vendor/bootstrap/js/bootstrap.min.js' %}"></script>
    <!-- IntroJS
    <link rel="stylesheet" href="{% static 'vendor/intro/introjs.css' %}">
    <script src="{% static 'vendor/intro/intro.js' %}"></script> -->

    <!-- Google font -->
    <link href="https://fonts.googleapis.com/css?family=Roboto" rel="stylesheet">

    <!-- Custom -->
    <link rel="stylesheet" href="{% static 'shared/css/style.css' %}">
    <link rel="stylesheet" href="{% static 'viewer/css/style.css' %}">
    <script src="{% static 'shared/js/custom.js' %}"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
</head>
<body>
    {% include "front/menu.html" %}

    <div class="container-fluid">
        <div id="main">
            <div class="panel-container">
                <div class="messages alert alert-danger"><span></span></div>
                <div class="panel-left">
                    {% include "viewer/menu.html" %}
                </div>
                <div class="splitter">
                </div>
                <div class="panel-center">
                    {% include "viewer/graphs.html" %}
                </div>
                 <div class="splitter"></div>
                <div class="panel-right">
                    {% include "viewer/map.html" %}
                </div>
            </div>
        </div>
    </div>

    {% include "front/footer.html" %}

    <script type="text/javascript">
        // Global vars
        var servicepath = '{{ wms_host }}';
        var did = '{{ wms_did|default:"deployment_" }}';

        var effects_duration = 300;     // time in ms
        var nav_menu_width = '25%';
        var nav_graphs_width = '25%';
        var nav_collapsed_width = 40;

        function removeChecks(deploy) {
            var chks = 0;
            $('[data-deploy=' + deploy + ']').each(function() {
                if (($(this).is("input") && $(this).is(":checked")) || ($(this).is("button") && $(this).hasClass('active'))) chks += 1;
            });
            if (chks == 0) $('#chk_' + deploy).removeAttr('checked');
        }

        $('#menu a, button').click(function() {
            $(this).blur();
        });

        // Show message notification and fadeout afterwards
        function show_alert(message, time) {
            $('.messages span').html(message);
            $('.messages').fadeIn();
            setTimeout(function () {
                $('.messages').fadeOut();
                $('.messages span').html('');
            }, time);
        }

        // Create custom slider effect
        function togglePanel(navid, spanelem) {
            var nextelem = $(spanelem).parent().next();
            var bodyelem = $('#' + navid).find('.panel-body')[0];

            // Set glyph icons and width according to panel beeing resized
            var collapsed_class = 'glyphicon-menu-hamburger';
            var expanded_class = 'glyphicon-chevron-left';
            var nav_width = nav_menu_width;
            var navelem = $('.panel-left');
            if (navid === "graphs") {
                collapsed_class = 'glyphicon-stats';
                nav_width = nav_graphs_width;
                navelem = $('.panel-center');
            }

            // Update width with animation
            if (spanelem.hasClass(collapsed_class)) {
                // Expand panel
                navelem.animate({ width: nav_width }, effects_duration, function() {
                    // refresh map size
                    map.invalidateSize(false);
                    if (navid === "graphs") {
                        $(Highcharts.charts).each(function(i, chart) {
                            if (typeof(chart) != "undefined") chart.setSize(navelem.width() - 40, null, doAnimation=true);
                        });
                    }
                });

                // Show contents
                $('#' + navid + ' .hidden').removeClass('hidden');

                // Enable resizable if expanded
                $(navelem).resizable("enable");

                // Update glyphs
                spanelem.removeClass(collapsed_class);
                spanelem.addClass(expanded_class);
            } else {
                // Collapse panel
                navelem.animate({ width: nav_collapsed_width }, effects_duration, function() {
                    // refresh map size
                    map.invalidateSize(false);
                });

                // Hide contents
                $(nextelem).addClass('hidden');
                $(bodyelem).addClass('hidden');

                // Disable resizable if collapsed
                $(navelem).resizable("disable");

                // Update glyphs
                spanelem.removeClass(expanded_class);
                spanelem.addClass(collapsed_class);
            }
        }

        $(function() {
            var block = $(window).width() / 4;
            var max_menu_width = block * 1.5;
            var max_graphs_width = block * 2.45;

            // Hide modal error texts
            $(".text-danger").hide();

            // Set panel-main's height removing header and footer
            $('#main').height($(window).height()-$("#header").height()-$("#footer").height());
            $('#menu .main-body').height($(window).height()-$("#header").height()-$("#footer").height()-40);
            $('#graphs .main-body').height($(window).height()-$("#header").height()-$("#footer").height()-40);

            // Do action on window resize
            $(window).resize(function() {
                // Set panel-main's height removing header and footer
                $('#main').height($(window).height()-$("#header").height()-$("#footer").height());

                // Set menu and graphs panel-body height
                $('#menu .main-body').height($(window).height()-$("#header").height()-$("#footer").height()-40);
                $('#graphs .main-body').height($(window).height()-$("#header").height()-$("#footer").height()-40);
            });

            $(".panel-left").resizable({
                handles: 'e',
                minWidth: 300,
                maxWidth: max_menu_width,
                handleSelector: ".splitter",
                resizeHeight: false,
                resize: function(event, ui) {
                    map.invalidateSize(false);
                },
                stop: function(event, ui) {
                    nav_menu_width = ui.size.width;                     // update global variable
                }
            });

            $(".panel-center").resizable({
                handles: 'e',
                minWidth: 300,
                maxWidth: max_graphs_width,
                handleSelector: ".splitter",
                resizeHeight: false,
                disabled: true, // starts disabled
                resize: function(event, ui) {
                    map.invalidateSize(false);
                },
                stop: function(event, ui) {
                    nav_graphs_width = ui.size.width;                     // update global variable
                    $(Highcharts.charts).each(function(i, chart) {
                        if (typeof(chart) != "undefined") chart.setSize(ui.size.width - 40, null, doAnimation=true);
                    });
                }
            });

            $('.files-table').DataTable({
                "searching": true,
                "info": false,
                "paging": false,
                "autoWidth": true,
                "ordering": true,
                "order": [[0,'desc']],
                "columns": [
                    { "title": "{% trans 'Data' %}", "type": 'date' },
                    { "title": "{% trans 'Ficheiro' %}", "orderable": false },
                ],
                "language": {
                    "emptyTable":       "{% trans 'Sem registos' %}",
                    "search":           "{% trans 'Pesquisar' %}",
                    "lengthMenu":       "_MENU_ {% trans 'registos' %}",
                    "paginate":
                    {
                        "previous": "<",
                        "next": ">",
                        "first": "<<",
                        "last": ">>"
                    }
                }
            });

            // Action on panel collapse/expand
            $('button.toggle').click(function() {
                var navid = $(this).closest('.panel-main').get(0).id;
                var spanelem = $(this).find('span');

                // Call custom slider effect
                togglePanel(navid, spanelem);
            });

            // Action on theme selection/unselection
            $('input[type="checkbox"][name="theme"]').change(function() {
                var deploy = $(this).data('deploy');

                if ($(this).is(':checked')) {
                    // Add to map
                    addWMSLayer(this);
                } else {
                    // Remove from map
                    removeWMSLayer(this);

                    // remove parent checkbox if all removed
                    removeChecks(deploy);
                }
            });

            // Update the level to the deployment's services
            $('.level').change(function() {
                // Get deploy
                var deploy = $(this).data('deploy');
                // Get level
                var level = $(this).val();

                // Update deployment's map services
                for (layer_id in services) {
                    var this_deploy = layer_id.split(/-(.+)/)[0];
                    var this_theme = layer_id.split(/-(.+)/)[1];
                    if (this_deploy == deploy && this_theme != "elev") {
                        var service = services[layer_id];
                        // Update the service elevation parameter
                        service.setParams({'elevation': level});
                    }
                }
            });
        });
    </script>

    <!-- Load JQuery dataTables -->
    <script src="{% static 'vendor/jquery-dataTables/jquery.dataTables.min.js' %}"></script>

</body>
</html>
